"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
exports.createRxjsMiddleware = (actions) => (store) => {
    const allActs = [];
    const action$ = new rxjs_1.Observable();
    store.context.action$ = action$;
    store.context.createAction$ = (type) => action$.pipe(operators_1.filter((act) => act.type === type), operators_1.map((act) => act.payload));
    for (const key in actions) {
        const curAct$ = action$.pipe(operators_1.filter((act) => act.type === key), operators_1.map((act) => act.payload));
        store.context.curAction$ = curAct$;
        allActs.push(actions[key](store.context, undefined));
    }
    const mergeOb$ = rxjs_1.merge(...allActs);
    const sub$ = new rxjs_1.Subject();
    action$.source = sub$;
    const dispatch = store.dispatch;
    const keys = Object.keys(actions);
    store.context.dispatch = store.dispatch = async (type, payload) => {
        if (keys.includes(type)) {
            sub$.next({ type, payload });
        }
        else {
            await dispatch(type, payload);
        }
    };
    mergeOb$.subscribe();
    return (next) => (mutation) => {
        return next(mutation);
    };
};
//# sourceMappingURL=createRxjsMiddleware.js.map